/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 32 "policy_parse.y" /* yacc.c:339  */

#include <sys/types.h>
#include <assert.h>
#include <stdarg.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdlib.h>

#include <sepol/policydb/expand.h>
#include <sepol/policydb/policydb.h>
#include <sepol/policydb/services.h>
#include <sepol/policydb/conditional.h>
#include <sepol/policydb/flask.h>
#include <sepol/policydb/hierarchy.h>
#include <sepol/policydb/polcaps.h>
#include "queue.h"
#include "checkpolicy.h"
#include "module_compiler.h"
#include "policy_define.h"

extern policydb_t *policydbp;
extern unsigned int pass;

extern char yytext[];
extern int yylex(void);
extern int yywarn(const char *msg);
extern int yyerror(const char *msg);

typedef int (* require_func_t)(int pass);


#line 103 "y.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    PATH = 258,
    QPATH = 259,
    FILENAME = 260,
    CLONE = 261,
    COMMON = 262,
    CLASS = 263,
    CONSTRAIN = 264,
    VALIDATETRANS = 265,
    INHERITS = 266,
    SID = 267,
    ROLE = 268,
    ROLEATTRIBUTE = 269,
    ATTRIBUTE_ROLE = 270,
    ROLES = 271,
    TYPEALIAS = 272,
    TYPEATTRIBUTE = 273,
    TYPEBOUNDS = 274,
    TYPE = 275,
    TYPES = 276,
    ALIAS = 277,
    ATTRIBUTE = 278,
    BOOL = 279,
    TUNABLE = 280,
    IF = 281,
    ELSE = 282,
    TYPE_TRANSITION = 283,
    TYPE_MEMBER = 284,
    TYPE_CHANGE = 285,
    ROLE_TRANSITION = 286,
    RANGE_TRANSITION = 287,
    SENSITIVITY = 288,
    DOMINANCE = 289,
    DOM = 290,
    DOMBY = 291,
    INCOMP = 292,
    CATEGORY = 293,
    LEVEL = 294,
    RANGE = 295,
    MLSCONSTRAIN = 296,
    MLSVALIDATETRANS = 297,
    USER = 298,
    NEVERALLOW = 299,
    ALLOW = 300,
    AUDITALLOW = 301,
    AUDITDENY = 302,
    DONTAUDIT = 303,
    ALLOWXPERM = 304,
    AUDITALLOWXPERM = 305,
    DONTAUDITXPERM = 306,
    NEVERALLOWXPERM = 307,
    SOURCE = 308,
    TARGET = 309,
    SAMEUSER = 310,
    FSCON = 311,
    PORTCON = 312,
    NETIFCON = 313,
    NODECON = 314,
    IBPKEYCON = 315,
    IBENDPORTCON = 316,
    PIRQCON = 317,
    IOMEMCON = 318,
    IOPORTCON = 319,
    PCIDEVICECON = 320,
    DEVICETREECON = 321,
    FSUSEXATTR = 322,
    FSUSETASK = 323,
    FSUSETRANS = 324,
    GENFSCON = 325,
    U1 = 326,
    U2 = 327,
    U3 = 328,
    R1 = 329,
    R2 = 330,
    R3 = 331,
    T1 = 332,
    T2 = 333,
    T3 = 334,
    L1 = 335,
    L2 = 336,
    H1 = 337,
    H2 = 338,
    NOT = 339,
    AND = 340,
    OR = 341,
    XOR = 342,
    CTRUE = 343,
    CFALSE = 344,
    IDENTIFIER = 345,
    NUMBER = 346,
    EQUALS = 347,
    NOTEQUAL = 348,
    IPV4_ADDR = 349,
    IPV6_ADDR = 350,
    MODULE = 351,
    VERSION_IDENTIFIER = 352,
    REQUIRE = 353,
    OPTIONAL = 354,
    POLICYCAP = 355,
    PERMISSIVE = 356,
    FILESYSTEM = 357,
    DEFAULT_USER = 358,
    DEFAULT_ROLE = 359,
    DEFAULT_TYPE = 360,
    DEFAULT_RANGE = 361,
    LOW_HIGH = 362,
    LOW = 363,
    HIGH = 364
  };
#endif
/* Tokens.  */
#define PATH 258
#define QPATH 259
#define FILENAME 260
#define CLONE 261
#define COMMON 262
#define CLASS 263
#define CONSTRAIN 264
#define VALIDATETRANS 265
#define INHERITS 266
#define SID 267
#define ROLE 268
#define ROLEATTRIBUTE 269
#define ATTRIBUTE_ROLE 270
#define ROLES 271
#define TYPEALIAS 272
#define TYPEATTRIBUTE 273
#define TYPEBOUNDS 274
#define TYPE 275
#define TYPES 276
#define ALIAS 277
#define ATTRIBUTE 278
#define BOOL 279
#define TUNABLE 280
#define IF 281
#define ELSE 282
#define TYPE_TRANSITION 283
#define TYPE_MEMBER 284
#define TYPE_CHANGE 285
#define ROLE_TRANSITION 286
#define RANGE_TRANSITION 287
#define SENSITIVITY 288
#define DOMINANCE 289
#define DOM 290
#define DOMBY 291
#define INCOMP 292
#define CATEGORY 293
#define LEVEL 294
#define RANGE 295
#define MLSCONSTRAIN 296
#define MLSVALIDATETRANS 297
#define USER 298
#define NEVERALLOW 299
#define ALLOW 300
#define AUDITALLOW 301
#define AUDITDENY 302
#define DONTAUDIT 303
#define ALLOWXPERM 304
#define AUDITALLOWXPERM 305
#define DONTAUDITXPERM 306
#define NEVERALLOWXPERM 307
#define SOURCE 308
#define TARGET 309
#define SAMEUSER 310
#define FSCON 311
#define PORTCON 312
#define NETIFCON 313
#define NODECON 314
#define IBPKEYCON 315
#define IBENDPORTCON 316
#define PIRQCON 317
#define IOMEMCON 318
#define IOPORTCON 319
#define PCIDEVICECON 320
#define DEVICETREECON 321
#define FSUSEXATTR 322
#define FSUSETASK 323
#define FSUSETRANS 324
#define GENFSCON 325
#define U1 326
#define U2 327
#define U3 328
#define R1 329
#define R2 330
#define R3 331
#define T1 332
#define T2 333
#define T3 334
#define L1 335
#define L2 336
#define H1 337
#define H2 338
#define NOT 339
#define AND 340
#define OR 341
#define XOR 342
#define CTRUE 343
#define CFALSE 344
#define IDENTIFIER 345
#define NUMBER 346
#define EQUALS 347
#define NOTEQUAL 348
#define IPV4_ADDR 349
#define IPV6_ADDR 350
#define MODULE 351
#define VERSION_IDENTIFIER 352
#define REQUIRE 353
#define OPTIONAL 354
#define POLICYCAP 355
#define PERMISSIVE 356
#define FILESYSTEM 357
#define DEFAULT_USER 358
#define DEFAULT_ROLE 359
#define DEFAULT_TYPE 360
#define DEFAULT_RANGE 361
#define LOW_HIGH 362
#define LOW 363
#define HIGH 364

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 69 "policy_parse.y" /* yacc.c:355  */

	unsigned int val;
	uint64_t val64;
	uintptr_t valptr;
	void *ptr;
        require_func_t require_func;

#line 369 "y.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 386 "y.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  9
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1359

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  120
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  197
/* YYNRULES -- Number of rules.  */
#define YYNRULES  404
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  810

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   364

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     115,   116,   119,     2,   114,   117,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   113,   112,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   110,     2,   111,   118,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   165,   165,   166,   168,   170,   173,   168,   177,   178,
     180,   183,   184,   186,   189,   191,   192,   194,   195,   197,
     200,   201,   203,   205,   207,   210,   211,   213,   214,   215,
     216,   217,   218,   219,   220,   222,   224,   227,   229,   232,
     234,   237,   239,   241,   243,   245,   247,   250,   251,   253,
     255,   256,   258,   260,   263,   265,   267,   270,   271,   273,
     274,   276,   278,   281,   282,   284,   286,   289,   290,   292,
     293,   295,   298,   301,   302,   304,   305,   306,   307,   308,
     309,   311,   312,   313,   314,   315,   316,   317,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   331,
     334,   336,   339,   342,   345,   348,   349,   351,   354,   357,
     359,   362,   365,   368,   370,   372,   375,   378,   381,   384,
     387,   390,   393,   397,   400,   402,   404,   406,   409,   412,
     415,   418,   422,   424,   426,   428,   431,   435,   439,   443,
     448,   450,   452,   454,   457,   459,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   472,   475,   478,   481,   484,
     487,   490,   493,   496,   499,   502,   505,   508,   510,   512,
     515,   518,   520,   523,   525,   528,   531,   532,   534,   535,
     537,   538,   540,   543,   546,   548,   551,   554,   557,   560,
     563,   566,   569,   569,   572,   572,   575,   575,   578,   578,
     581,   581,   584,   584,   587,   587,   590,   590,   593,   593,
     596,   599,   599,   602,   602,   605,   608,   608,   611,   611,
     614,   617,   620,   623,   626,   629,   633,   635,   638,   640,
     642,   644,   647,   648,   650,   653,   654,   656,   657,   659,
     662,   662,   664,   665,   667,   668,   669,   670,   671,   673,
     676,   678,   681,   683,   686,   689,   692,   693,   695,   696,
     698,   701,   703,   704,   706,   707,   709,   711,   714,   715,
     717,   718,   720,   722,   725,   726,   728,   729,   731,   734,
     735,   737,   738,   740,   743,   744,   746,   747,   749,   751,
     754,   755,   757,   758,   760,   762,   764,   767,   768,   770,
     771,   773,   775,   775,   777,   780,   783,   785,   787,   789,
     793,   795,   796,   798,   798,   799,   800,   802,   805,   807,
     808,   810,   812,   815,   817,   820,   821,   823,   825,   827,
     829,   831,   834,   837,   840,   840,   843,   846,   849,   850,
     851,   852,   853,   855,   856,   858,   861,   862,   864,   866,
     866,   868,   868,   868,   868,   870,   873,   875,   878,   880,
     883,   886,   889,   892,   895,   898,   903,   908,   911,   913,
     915,   917,   919,   920,   922,   923,   924,   925,   926,   927,
     929,   931,   932,   934,   935,   937,   940,   941,   942,   943,
     944,   945,   946,   947,   948,   950,   952,   956,   955,   960,
     962,   964,   967,   970,   971
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "PATH", "QPATH", "FILENAME", "CLONE",
  "COMMON", "CLASS", "CONSTRAIN", "VALIDATETRANS", "INHERITS", "SID",
  "ROLE", "ROLEATTRIBUTE", "ATTRIBUTE_ROLE", "ROLES", "TYPEALIAS",
  "TYPEATTRIBUTE", "TYPEBOUNDS", "TYPE", "TYPES", "ALIAS", "ATTRIBUTE",
  "BOOL", "TUNABLE", "IF", "ELSE", "TYPE_TRANSITION", "TYPE_MEMBER",
  "TYPE_CHANGE", "ROLE_TRANSITION", "RANGE_TRANSITION", "SENSITIVITY",
  "DOMINANCE", "DOM", "DOMBY", "INCOMP", "CATEGORY", "LEVEL", "RANGE",
  "MLSCONSTRAIN", "MLSVALIDATETRANS", "USER", "NEVERALLOW", "ALLOW",
  "AUDITALLOW", "AUDITDENY", "DONTAUDIT", "ALLOWXPERM", "AUDITALLOWXPERM",
  "DONTAUDITXPERM", "NEVERALLOWXPERM", "SOURCE", "TARGET", "SAMEUSER",
  "FSCON", "PORTCON", "NETIFCON", "NODECON", "IBPKEYCON", "IBENDPORTCON",
  "PIRQCON", "IOMEMCON", "IOPORTCON", "PCIDEVICECON", "DEVICETREECON",
  "FSUSEXATTR", "FSUSETASK", "FSUSETRANS", "GENFSCON", "U1", "U2", "U3",
  "R1", "R2", "R3", "T1", "T2", "T3", "L1", "L2", "H1", "H2", "NOT", "AND",
  "OR", "XOR", "CTRUE", "CFALSE", "IDENTIFIER", "NUMBER", "EQUALS",
  "NOTEQUAL", "IPV4_ADDR", "IPV6_ADDR", "MODULE", "VERSION_IDENTIFIER",
  "REQUIRE", "OPTIONAL", "POLICYCAP", "PERMISSIVE", "FILESYSTEM",
  "DEFAULT_USER", "DEFAULT_ROLE", "DEFAULT_TYPE", "DEFAULT_RANGE",
  "LOW_HIGH", "LOW", "HIGH", "'{'", "'}'", "';'", "':'", "','", "'('",
  "')'", "'-'", "'~'", "'*'", "$accept", "policy", "base_policy", "$@1",
  "$@2", "$@3", "classes", "class_def", "initial_sids", "initial_sid_def",
  "access_vectors", "opt_common_perms", "common_perms", "common_perms_def",
  "av_perms", "av_perms_def", "opt_default_rules", "default_rules",
  "default_user_def", "default_role_def", "default_type_def",
  "default_range_def", "opt_mls", "mls", "sensitivities",
  "sensitivity_def", "alias_def", "dominance", "opt_categories",
  "categories", "category_def", "levels", "level_def", "mlspolicy",
  "mlspolicy_decl", "mlsconstraint_def", "mlsvalidatetrans_def", "te_rbac",
  "te_rbac_decl", "rbac_decl", "te_decl", "attribute_def", "type_def",
  "typealias_def", "typeattribute_def", "typebounds_def", "opt_attr_list",
  "bool_def", "tunable_def", "bool_val", "cond_stmt_def", "cond_else",
  "cond_expr", "cond_expr_prim", "cond_pol_list", "cond_rule_def",
  "cond_transition_def", "cond_te_avtab_def", "cond_allow_def",
  "cond_auditallow_def", "cond_auditdeny_def", "cond_dontaudit_def",
  "transition_def", "range_trans_def", "te_avtab_def", "allow_def",
  "auditallow_def", "auditdeny_def", "dontaudit_def", "neverallow_def",
  "xperm_allow_def", "xperm_auditallow_def", "xperm_dontaudit_def",
  "xperm_neverallow_def", "attribute_role_def", "role_type_def",
  "role_attr_def", "role_dominance", "role_trans_def", "role_allow_def",
  "roles", "role_def", "roleattribute_def", "opt_constraints",
  "constraints", "constraint_decl", "constraint_def", "validatetrans_def",
  "cexpr", "cexpr_prim", "$@4", "$@5", "$@6", "$@7", "$@8", "$@9", "$@10",
  "$@11", "$@12", "$@13", "$@14", "$@15", "$@16", "op", "role_mls_op",
  "users", "user_def", "opt_mls_user", "initial_sid_contexts",
  "initial_sid_context_def", "opt_dev_contexts", "dev_contexts",
  "dev_context_def", "pirq_context_def", "iomem_context_def",
  "ioport_context_def", "pci_context_def", "dtree_context_def",
  "opt_fs_contexts", "fs_contexts", "fs_context_def", "net_contexts",
  "opt_port_contexts", "port_contexts", "port_context_def",
  "opt_ibpkey_contexts", "ibpkey_contexts", "ibpkey_context_def",
  "opt_ibendport_contexts", "ibendport_contexts", "ibendport_context_def",
  "opt_netif_contexts", "netif_contexts", "netif_context_def",
  "opt_node_contexts", "node_contexts", "node_context_def", "opt_fs_uses",
  "fs_uses", "fs_use_def", "opt_genfs_contexts", "genfs_contexts",
  "genfs_context_def", "$@17", "ipv4_addr_def", "xperms",
  "nested_xperm_set", "nested_xperm_list", "nested_xperm_element", "$@18",
  "xperm", "security_context_def", "opt_mls_range_def", "mls_range_def",
  "mls_level_def", "id_comma_list", "tilde", "asterisk", "names", "$@19",
  "tilde_push", "asterisk_push", "names_push", "identifier_list_push",
  "identifier_push", "identifier_list", "nested_id_set", "nested_id_list",
  "nested_id_element", "$@20", "identifier", "filesystem", "path",
  "filename", "number", "number64", "ipv6_addr", "policycap_def",
  "permissive_def", "module_policy", "module_def", "version_identifier",
  "avrules_block", "avrule_decls", "avrule_decl", "require_block",
  "require_list", "require_decl", "require_class", "require_decl_def",
  "require_id_list", "optional_block", "$@21", "optional_else",
  "optional_decl", "else_decl", "avrule_user_defs", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     123,   125,    59,    58,    44,    40,    41,    45,   126,    42
};
# endif

#define YYPACT_NINF -705

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-705)))

#define YYTABLE_NINF -229

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -52,   -17,    91,  -705,   129,  -705,   548,  -705,   324,  -705,
     -17,   139,  -705,   -17,   -17,   -17,   -17,   -17,   -17,   -17,
     -17,   -17,   -17,     5,   119,   119,   119,   119,   119,    74,
     119,   119,   119,   119,   119,   119,   119,   119,   119,    80,
    -705,   -17,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,   333,  -705,  -705,  -705,    96,  -705,
    -705,  -705,  -705,  -705,   110,  -705,   -17,  -705,   216,  -705,
      15,   -17,   154,   234,   -17,   -17,    12,   159,   266,   266,
       5,     5,   232,  -705,  -705,    42,  -705,  -705,   164,  -705,
     119,  -705,   185,   119,   119,   119,   119,   286,   119,   119,
     119,   119,   119,   119,   119,   119,   119,   384,   203,   -17,
     289,  -705,  -705,   548,  -705,  -705,   -17,  -705,  -705,   329,
     353,  -705,   119,   -17,   228,   291,  -705,  -705,   119,   254,
     341,   368,   292,   304,  -705,  -705,  -705,   328,   336,   282,
     -15,     5,     5,     5,     5,     5,  -705,  -705,  -705,    97,
    -705,  -705,  -705,  -705,   339,  -705,   356,   359,   -16,    35,
     389,    19,  -705,   363,   274,   387,   405,   409,   457,   462,
     468,   478,   -17,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,    22,  -705,   489,   -17,  -705,   527,  -705,   491,
     498,   320,   -17,   329,  -705,  -705,   497,   490,  -705,  -705,
     -17,  -705,  -705,  -705,  -705,   499,  -705,  -705,  -705,  -705,
     282,   246,   308,  -705,  -705,   197,   -17,  -705,  -705,   119,
     -17,   119,   119,   119,   501,   119,   502,   486,   503,  -705,
     404,  -705,  -705,   119,  -705,   119,   119,   119,   119,   119,
     119,   119,   119,   119,  -705,  -705,  -705,  -705,   427,   119,
    -705,   -17,   119,   119,   119,   119,   577,   320,  -705,  -705,
    -705,  -705,    17,  -705,  -705,  -705,  -705,   119,   119,   119,
     119,   119,   119,   119,   588,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,   -17,  -705,   -17,   -17,   -17,  -705,
     -17,  -705,   -17,   -17,   286,  -705,   119,   119,   119,   119,
     119,   -17,   -17,   -17,   -17,  -705,  -705,   -17,   578,   592,
       2,  -705,   431,   474,   492,   494,   -17,   822,  -705,   386,
    -705,  -705,  -705,  -705,  -705,   -17,   -17,   119,   119,   119,
     119,   119,   119,   119,   510,  -705,     6,   509,   511,   512,
     513,  -705,   490,    20,   514,   515,   516,   517,   519,    31,
      31,    31,    31,  -705,   -17,   520,  -705,  -705,   523,  -705,
    -705,   522,   524,   525,   526,   528,   529,    73,   263,    26,
     -17,  -705,   506,  -705,  -705,  -705,  -705,  -705,  -705,   172,
    -705,   597,   532,    99,   530,   531,   535,   537,   538,   541,
     543,  -705,  -705,  -705,   533,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,    55,   545,  -705,  -705,    55,
    -705,   546,   547,   549,   582,  -705,   548,  -705,  -705,  -705,
    -705,  -705,  -705,   550,   551,   552,   553,   554,   555,  -705,
     556,   557,  -705,    53,  -705,   -17,  -705,   -17,   591,   597,
    -705,   -17,  -705,   119,   119,   119,   119,   119,   119,   119,
     366,  -705,  -705,   258,  -705,   558,  -705,  -705,  -705,  -705,
    -705,  -705,   -17,   559,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,   119,   119,  -705,   448,  -705,  -705,  -705,  -705,
     140,    28,   -17,   349,  -705,  -705,   141,   -17,   -17,   -17,
     119,   119,   119,   119,  -705,  -705,  -705,  -705,  -705,  -705,
     119,   121,   627,  -705,  -705,  -705,   560,   471,   119,   119,
    -705,   518,  -705,  -705,  -705,  -705,    24,   561,   562,   564,
     565,   566,   567,   580,   121,    51,   321,   323,  -705,   493,
     493,   493,    51,   493,   493,   493,   493,   493,    51,    51,
      51,   121,   121,    71,  -705,   -17,    47,  -705,  -705,  -705,
     -17,   119,   121,  -705,  -705,   570,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,   161,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,   611,  -705,  -705,   612,   613,
    -705,  -705,   615,  -705,  -705,   347,   606,   352,  -705,    -5,
     121,   121,  -705,   -17,   580,  -705,   429,   634,  -705,   430,
     121,   182,  -705,  -705,   130,   130,   130,   130,  -705,   130,
     130,   130,   130,  -705,   130,   130,  -705,   130,   130,   130,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,   609,  -705,
     583,   580,   226,   -17,   -17,   621,   429,  -705,  -705,  -705,
     215,  -705,   389,  -705,  -705,   220,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,   -17,   -17,  -705,  -705,   -17,   -17,   -17,   226,   638,
     621,  -705,  -705,  -705,   142,  -705,   389,  -705,   586,   -17,
     585,   589,   590,   584,   -17,   447,   642,   638,  -705,  -705,
    -705,  -705,   186,   -17,  -705,  -705,  -705,  -705,  -705,  -705,
      49,   580,   580,   614,   580,   580,   584,   644,   447,  -705,
    -705,  -705,  -705,  -705,  -705,   -17,   647,   642,  -705,  -705,
    -705,   594,    68,  -705,   144,   -17,  -705,   173,   179,   -17,
     -17,   616,   648,   644,  -705,  -705,   -17,   495,  -705,   647,
    -705,  -705,   -17,  -705,  -705,   -17,   580,  -705,  -705,   614,
    -705,   580,  -705,  -705,  -705,  -705,   580,   -17,  -705,   648,
    -705,  -705,   -17,   619,   616,  -705,  -705,   -17,  -705,   -17,
     -17,   -17,   187,   580,  -705,  -705,   -17,   -17,  -705,  -705,
    -705,  -705,   580,  -705,   -17,  -705,  -705,   -17,  -705,  -705
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     2,     0,     3,     0,   355,     0,     1,
       0,     0,     8,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     401,     0,   379,   374,   375,    88,    89,    90,    91,    92,
      93,    94,   376,    95,    96,    97,   146,   147,   148,   149,
     150,   151,   152,   153,   154,    81,    82,    87,    83,    84,
      85,    86,    98,   366,   404,   373,   377,   378,     0,   361,
     305,   368,   370,   369,     0,    10,     0,     9,    16,    11,
     106,     0,     0,     0,     0,     0,   106,     0,     0,     0,
       0,     0,     0,   121,   122,     0,   327,   328,     0,   331,
       0,   330,   329,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     404,   372,   371,     0,   367,    13,     0,    12,     5,     0,
      15,    17,     0,     0,     0,     0,   325,   164,     0,     0,
       0,     0,   106,     0,    99,   109,   110,     0,     0,   115,
       0,     0,     0,     0,     0,     0,   124,   352,   354,     0,
     349,   351,   333,   332,     0,   334,     0,     0,     0,     0,
       0,     0,   171,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   386,   389,   387,   388,   391,   392,   393,
     394,   390,     0,   382,     0,     0,   365,     0,   403,     0,
       0,    26,     0,    14,    20,    18,     0,   105,   166,   175,
       0,    54,   102,   103,   104,     0,   101,   107,   108,   114,
     116,   117,   118,   119,   120,     0,     0,   348,   350,     0,
       0,     0,     0,     0,     0,     0,     0,   322,   324,   345,
       0,   167,   172,     0,   170,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   380,   381,   383,   395,     0,     0,
     397,     0,     0,     0,     0,     0,    48,    25,    27,    28,
      29,    30,     0,    21,   165,   326,   100,     0,     0,     0,
       0,     0,     0,     0,   113,   123,   125,   126,   132,   133,
     134,   135,   127,   353,     0,   335,     0,     0,     0,   168,
       0,   144,     0,     0,     0,   173,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   385,   384,     0,   236,   400,
       0,   346,     0,     0,     0,     0,     0,     0,    47,     0,
      50,    31,    32,    33,    34,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   111,     0,     0,     0,     0,
       0,   321,   323,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   396,     0,     0,   402,   398,     0,    19,
     347,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    80,     0,    73,    76,    75,    77,    79,    78,     0,
      51,    58,    23,     0,     0,     0,     0,     0,     0,     0,
       0,   124,   360,   141,     0,   142,   143,   169,   145,   174,
     159,   155,   156,   157,   158,     0,     0,   307,   306,     0,
     317,     0,     0,     0,     0,   234,     0,    35,    36,    37,
      38,    39,    40,     0,     0,     0,     0,     0,     0,    53,
       0,     0,    74,   177,   232,     0,    55,     0,     0,    57,
      59,     0,    22,     0,     0,     0,     0,     0,     0,     0,
       0,   140,   316,     0,   311,   315,   160,   309,   308,   161,
     162,   163,     0,     0,    43,    41,    42,    46,    44,    45,
      52,   364,     0,     0,     6,   176,   178,   180,   181,   233,
       0,     0,     0,     0,    63,    60,     0,     0,     0,     0,
       0,     0,     0,     0,   112,   310,   312,   313,   235,   399,
       0,     0,     0,   179,    56,    62,     0,     0,     0,     0,
      64,    49,    67,    69,    70,    24,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   188,     0,   257,   237,    61,    66,
       0,     0,     0,    68,   129,     0,   130,   131,   136,   137,
     138,   139,   314,     0,   229,   230,   231,   226,   227,   228,
     215,   211,   216,   213,   218,   192,   194,   196,   198,     0,
     200,   202,   204,   206,   208,     0,     0,     0,   185,     0,
       0,     0,   183,     0,     0,   238,   291,   256,   258,     0,
       0,     0,   128,   182,     0,     0,     0,     0,   189,     0,
       0,     0,     0,   190,     0,     0,   191,     0,     0,     0,
     220,   224,   221,   225,   222,   223,   184,   186,   187,   239,
       0,     0,     0,     0,     0,   298,   290,   292,   259,    65,
       0,    72,     0,   336,   337,     0,   340,   212,   338,   217,
     214,   219,   193,   195,   197,   199,   201,   203,   205,   207,
     209,     0,     0,   357,   356,     0,     0,     0,     0,   263,
     297,   299,   293,    71,     0,   343,     0,   341,     0,     0,
       0,     0,     0,     0,     0,   241,   280,   262,   264,   300,
     339,   344,     0,     0,   260,   294,   295,   296,   358,   359,
       0,     0,     0,     0,     0,     0,     0,   269,   240,   242,
     244,   245,   246,   247,   248,     0,   285,   279,   281,   265,
     342,   320,     0,   304,     0,     0,   362,     0,     0,     0,
       0,     0,   275,   268,   270,   243,     0,     0,   261,   284,
     286,   282,     0,   318,   302,     0,     0,   266,   249,     0,
     250,     0,   252,   254,   255,   363,     0,     0,     7,   274,
     276,   271,     0,     0,     0,   287,   319,     0,   301,     0,
       0,     0,     0,     0,   277,   283,     0,     0,   303,   267,
     251,   253,     0,   272,     0,   288,   289,     0,   278,   273
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -705,  -705,  -705,  -705,  -705,  -705,  -705,   697,  -705,   622,
    -705,  -705,  -705,   574,  -705,   504,  -705,  -705,   438,   439,
     441,   443,  -705,  -705,  -705,   382,   -91,  -705,  -705,  -705,
     264,  -705,   219,  -705,   193,  -705,  -705,  -705,   334,  -294,
    -276,  -705,  -705,  -705,  -705,  -705,   -42,  -705,  -705,   626,
    -271,  -705,     8,  -705,   316,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
     414,  -177,  -705,  -705,  -705,   235,  -705,  -705,  -505,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,   -62,  -476,  -705,  -334,  -705,  -705,   163,
    -705,  -705,     3,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
     115,  -705,  -705,  -705,    29,  -705,  -705,   -20,  -705,  -705,
     -44,  -705,  -705,     0,  -705,  -705,   -21,  -705,  -705,    83,
    -705,  -705,    50,  -705,  -704,   132,  -361,  -705,   269,  -705,
    -398,  -532,  -705,  -303,  -260,   -92,  -346,  -188,   788,  -705,
    -705,  -705,  -164,    54,  -179,  -338,   -67,  -705,   576,  -705,
      -1,    63,    27,   218,    41,   -13,  -470,  -705,  -705,  -705,
    -705,  -705,  -123,  -705,   678,  -229,  -705,   568,  -705,  -705,
    -705,  -268,  -705,  -705,  -705,  -705,   628
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,     4,   211,   522,    11,    12,    88,    89,
     138,   139,   140,   141,   213,   214,   276,   277,   278,   279,
     280,   281,   337,   338,   339,   340,   149,   401,   458,   459,
     460,   503,   504,   531,   532,   533,   534,   392,   393,    43,
      44,    45,    46,    47,    48,    49,   144,    50,    51,   157,
      52,   355,   102,   103,   235,   295,   296,   297,   298,   299,
     300,   301,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
     181,   182,    71,   494,   495,   496,   497,   498,   563,   564,
     629,   630,   631,   632,   634,   635,   637,   638,   639,   624,
     626,   625,   627,   589,   590,   453,   130,   375,   566,   567,
     727,   728,   729,   730,   731,   732,   733,   734,   616,   617,
     618,   705,   706,   707,   708,   752,   753,   754,   778,   779,
     780,   736,   737,   738,   758,   759,   760,   655,   656,   657,
     689,   690,   691,   787,    82,   426,   427,   473,   474,   543,
     428,   649,   763,   246,   247,   145,   108,   109,   110,   240,
     665,   666,   667,   694,   668,   330,   111,   169,   170,   236,
     112,   685,   720,   414,   430,   747,   776,   397,    72,     5,
       6,    84,    73,    74,    75,    76,   202,   203,   204,   205,
     268,    77,   329,   377,    78,   378,   132
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
       8,   250,   150,   151,   252,   152,   302,   360,   403,    85,
     209,   412,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   104,   429,   429,   429,   429,   475,   345,   412,
     192,   478,   180,   180,   148,   193,   142,   194,   168,   583,
     128,   172,   195,   394,     1,   196,   197,   198,   148,    83,
     148,   217,   361,   783,   153,   199,   608,   609,   454,   565,
     200,   395,   492,   493,   472,   201,   396,   621,   477,   398,
     161,   162,   163,     7,     7,   475,   599,   164,   165,   796,
     610,   611,   605,   606,   607,   135,   584,   585,   586,   100,
     146,     9,     7,   146,   146,     7,   129,   243,   394,   104,
     104,   229,   168,   614,   171,   647,   648,   173,   159,   160,
     225,   646,   472,   379,   434,   660,   395,   500,   413,   499,
     101,   396,    79,   506,   398,     7,   143,   346,   207,   143,
     251,   419,     7,   264,   545,   210,   574,    10,   449,     7,
     525,   425,   146,   587,   588,   582,    79,    10,   245,   106,
     699,    86,   105,   700,   701,   702,   610,   611,     7,   167,
     104,   104,   104,   104,   104,   425,   742,   714,   171,   230,
     231,   232,   233,   234,   546,   547,   548,   244,   248,   518,
     443,   444,   445,   612,   117,   764,   252,     7,   743,     7,
     127,   263,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   267,   561,   133,   105,   237,     7,
     462,   282,   767,   768,   167,   770,   772,   773,   774,   285,
     249,   362,   134,   136,   782,   287,   288,   289,    86,   105,
       7,     7,   249,   788,     7,   303,   562,   106,   107,   305,
     662,   302,   290,   291,   292,   293,   610,   611,   106,   107,
     795,   524,   535,   710,     7,   798,   148,   799,   800,   801,
     803,   766,     7,     7,   805,   806,   147,   610,   611,     7,
     331,   154,   808,   623,   105,   809,   249,     7,   663,   663,
     663,   663,   455,   663,   663,   663,   663,   784,   663,   663,
     769,   663,   663,   663,   661,    39,   771,   740,   450,   180,
     610,   611,   175,   356,   802,   357,   358,   359,   294,   248,
     249,   248,   146,   483,   797,   206,   683,   161,   162,   163,
     369,   370,   371,   372,   164,   165,   373,   693,   684,   380,
     696,   161,   129,   163,   591,   389,   593,   212,   164,   165,
     218,   592,   166,   594,   402,   331,    13,    14,    15,    79,
      16,    17,    18,    19,   155,   156,    20,    21,    22,    23,
     136,    24,    25,    26,    27,    28,   222,    29,   425,   515,
     446,   447,   448,   248,   164,   165,   129,    30,    31,    32,
      33,    34,    35,    36,    37,    38,   254,   255,   502,   451,
     528,   529,   192,   161,   287,   288,   289,   193,   456,   194,
     164,   165,   380,   219,   195,   220,   143,   196,   197,   198,
     526,   290,   291,   292,   293,    79,   226,   199,    80,   336,
     399,    81,   200,   272,   273,   274,   275,   201,   640,   641,
     642,    39,    40,   644,    41,   645,   664,   664,   664,   664,
     227,   664,   664,   664,   664,    42,   664,   664,   228,   664,
     664,   664,   239,   223,   331,   220,   501,   492,   493,   786,
     331,   669,   670,   671,    39,   672,   673,   674,   675,   241,
     676,   677,   242,   678,   679,   680,   253,   514,   619,   249,
     224,   248,   220,   695,   381,   382,   697,   595,   596,   597,
     598,   600,   601,   602,   603,   604,   652,   653,   654,   380,
     256,   527,   431,   432,   433,   380,   536,   537,   538,   722,
     723,   724,   725,   726,   314,   711,   315,   695,   257,    13,
      14,    15,   258,    16,    17,    18,    19,   383,   384,    20,
      21,    22,    23,   711,    24,    25,    26,    27,    28,   326,
      29,   327,   659,   269,   220,   385,   386,   387,   388,   129,
      30,    31,    32,    33,    34,    35,    36,    37,    38,   528,
     529,    13,    14,    15,   613,    16,    17,    18,    19,   146,
     259,    20,    21,    22,    23,   260,    24,    25,    26,    27,
      28,   261,    29,   569,   570,   587,   588,   718,   719,    80,
     775,   262,    30,    31,    32,    33,    34,    35,    36,    37,
      38,   266,   270,   312,   220,    40,   390,    41,   271,   284,
     336,   286,   650,   309,   311,   354,   313,   374,   391,   376,
     411,   415,   482,   416,   417,   418,   420,   421,   422,   423,
     502,   424,   435,   436,   437,   457,   438,   439,   440,   565,
     441,   442,   461,   463,   464,   471,    39,    40,   465,    41,
     466,   467,   686,   687,   468,   651,   469,   476,   479,   480,
      42,   481,   484,   485,   486,   487,   488,   489,   490,   491,
     519,    79,   568,   576,   577,   517,   578,   579,   580,   581,
     698,   650,   622,   628,   650,   650,   650,  -228,   633,   643,
     614,   688,   682,   636,   610,   704,   681,   715,   650,   713,
     735,   716,   717,   721,   751,   746,   757,   762,    87,   777,
     137,   775,   741,    80,   215,   341,   342,   283,   343,   650,
     344,   400,   530,   505,   573,   158,   452,   470,   363,   615,
     523,   755,   658,   781,   756,   794,   739,   761,   785,   692,
     709,   765,   516,   650,   650,   238,   650,   650,   650,   650,
     712,   703,   131,   750,   575,   650,   790,     0,   208,     0,
       0,   248,   744,   745,   650,   748,   749,     0,     0,     0,
     265,     0,     0,     0,     0,     0,   793,     0,     0,     0,
       0,   650,     0,     0,     0,     0,   650,     0,   650,   650,
     650,   650,     0,     0,     0,   650,   650,     0,     0,     0,
       0,     0,     0,   650,     0,     0,   650,   789,     0,     0,
       0,     0,   791,   113,   114,   115,   116,   792,   118,   119,
     120,   121,   122,   123,   124,   125,   126,     0,     0,     0,
       0,     0,     0,     0,   804,    13,    14,    15,     0,    16,
      17,    18,    19,   807,     0,    20,    21,    22,    23,     0,
      24,    25,    26,    27,    28,     0,    29,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    30,    31,    32,    33,
      34,    35,    36,    37,    38,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,     0,
       0,   176,   177,   178,   179,     0,   183,   184,   185,   186,
     187,   188,   189,   190,   191,     0,     0,     0,     0,     0,
       0,    40,   390,    41,     0,     0,     0,     0,     0,     0,
     216,     0,     0,     0,   391,     0,   221,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   304,     0,   306,
     307,   308,     0,   310,     0,     0,     0,     0,     0,     0,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
     324,   325,     0,     0,     0,     0,     0,   328,     0,     0,
     332,   333,   334,   335,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   347,   348,   349,   350,   351,
     352,   353,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   364,   365,   366,   367,   368,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   404,   405,   406,   407,   408,
     409,   410,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   507,   508,   509,   510,   511,   512,   513,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     520,   521,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   539,   540,
     541,   542,     0,     0,     0,     0,     0,     0,   544,     0,
       0,     0,     0,     0,     0,     0,   571,   572,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   620
};

static const yytype_int16 yycheck[] =
{
       1,   180,    94,    95,   181,    96,   235,   310,   346,    10,
     133,     5,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,   369,   370,   371,   372,   425,    11,     5,
       8,   429,    13,    13,    22,    13,    21,    15,   105,   544,
      41,   108,    20,   337,    96,    23,    24,    25,    22,     8,
      22,   143,   312,   757,    96,    33,   561,   562,   392,    12,
      38,   337,     9,    10,   425,    43,   337,   572,   429,   337,
      85,    86,    87,    90,    90,   473,   552,    92,    93,   783,
      85,    86,   558,   559,   560,    86,    35,    36,    37,    84,
      91,     0,    90,    94,    95,    90,    43,   113,   392,   100,
     101,   116,   169,    56,   105,   610,   611,   108,   100,   101,
     152,   116,   473,   111,   374,   620,   392,   455,   112,   453,
     115,   392,    91,   461,   392,    90,   114,   110,   129,   114,
     111,   111,    90,   111,    13,   136,   112,     8,   112,    90,
     112,   110,   143,    92,    93,   543,    91,     8,   113,   118,
     682,    12,   110,   685,   686,   687,    85,    86,    90,   117,
     161,   162,   163,   164,   165,   110,   117,   699,   169,   161,
     162,   163,   164,   165,    53,    54,    55,   178,   179,   482,
     107,   108,   109,   112,   110,   117,   363,    90,   720,    90,
     110,   192,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,   205,    84,   110,   110,   111,    90,
     111,   212,   744,   745,   117,   747,   748,   749,   750,   220,
      90,   313,   112,     7,   756,    28,    29,    30,    12,   110,
      90,    90,    90,   765,    90,   236,   115,   118,   119,   240,
     110,   470,    45,    46,    47,    48,    85,    86,   118,   119,
     782,   111,   111,   111,    90,   787,    22,   789,   790,   791,
     792,   117,    90,    90,   796,   797,   112,    85,    86,    90,
     271,   112,   804,   112,   110,   807,    90,    90,   624,   625,
     626,   627,   110,   629,   630,   631,   632,   757,   634,   635,
     117,   637,   638,   639,   112,    98,   117,   111,   389,    13,
      85,    86,   117,   304,   117,   306,   307,   308,   111,   310,
      90,   312,   313,   436,   784,   112,    90,    85,    86,    87,
     321,   322,   323,   324,    92,    93,   327,   112,   102,   330,
     110,    85,    43,    87,    13,   336,    13,     8,    92,    93,
     112,    20,   110,    20,   345,   346,    13,    14,    15,    91,
      17,    18,    19,    20,    88,    89,    23,    24,    25,    26,
       7,    28,    29,    30,    31,    32,   112,    34,   110,   111,
     107,   108,   109,   374,    92,    93,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,   112,   113,    39,   390,
      41,    42,     8,    85,    28,    29,    30,    13,   399,    15,
      92,    93,   403,   112,    20,   114,   114,    23,    24,    25,
     501,    45,    46,    47,    48,    91,   112,    33,    94,    33,
      34,    97,    38,   103,   104,   105,   106,    43,    81,    82,
      83,    98,    99,    81,   101,    83,   624,   625,   626,   627,
     112,   629,   630,   631,   632,   112,   634,   635,   112,   637,
     638,   639,   113,   112,   455,   114,   457,     9,    10,   762,
     461,   625,   626,   627,    98,   629,   630,   631,   632,   113,
     634,   635,   113,   637,   638,   639,   113,   111,   570,    90,
     112,   482,   114,   662,    53,    54,   665,   549,   550,   551,
     552,   553,   554,   555,   556,   557,    67,    68,    69,   500,
     113,   502,   370,   371,   372,   506,   507,   508,   509,    62,
      63,    64,    65,    66,   110,   694,   112,   696,   113,    13,
      14,    15,   113,    17,    18,    19,    20,    53,    54,    23,
      24,    25,    26,   712,    28,    29,    30,    31,    32,   112,
      34,   114,   112,    16,   114,    53,    54,    53,    54,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    41,
      42,    13,    14,    15,   565,    17,    18,    19,    20,   570,
     113,    23,    24,    25,    26,   113,    28,    29,    30,    31,
      32,   113,    34,   112,   113,    92,    93,     3,     4,    94,
      95,   113,    44,    45,    46,    47,    48,    49,    50,    51,
      52,   112,   111,   117,   114,    99,   100,   101,   110,   112,
      33,   112,   613,   112,   112,    27,   113,    39,   112,    27,
     110,   112,    40,   112,   112,   112,   112,   112,   112,   112,
      39,   112,   112,   110,   112,    38,   112,   112,   112,    12,
     112,   112,   110,   113,   113,   112,    98,    99,   113,   101,
     113,   113,   653,   654,   113,   614,   113,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     111,    91,   112,   112,   112,   117,   112,   112,   112,   112,
     681,   682,   112,    72,   685,   686,   687,    75,    75,    83,
      56,    70,   651,    78,    85,    57,   113,   112,   699,   113,
      58,   112,   112,   704,    60,    91,    59,   113,    11,    61,
      88,    95,   713,    94,   140,   277,   277,   213,   277,   720,
     277,   339,   503,   459,   531,    99,   392,   411,   314,   566,
     495,   728,   617,   753,   735,   779,   707,   737,   759,   656,
     690,   742,   473,   744,   745,   169,   747,   748,   749,   750,
     696,   688,    74,   726,   536,   756,   769,    -1,   130,    -1,
      -1,   762,   721,   722,   765,   724,   725,    -1,    -1,    -1,
     202,    -1,    -1,    -1,    -1,    -1,   777,    -1,    -1,    -1,
      -1,   782,    -1,    -1,    -1,    -1,   787,    -1,   789,   790,
     791,   792,    -1,    -1,    -1,   796,   797,    -1,    -1,    -1,
      -1,    -1,    -1,   804,    -1,    -1,   807,   766,    -1,    -1,
      -1,    -1,   771,    25,    26,    27,    28,   776,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   793,    13,    14,    15,    -1,    17,
      18,    19,    20,   802,    -1,    23,    24,    25,    26,    -1,
      28,    29,    30,    31,    32,    -1,    34,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,    -1,
      -1,   113,   114,   115,   116,    -1,   118,   119,   120,   121,
     122,   123,   124,   125,   126,    -1,    -1,    -1,    -1,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
     142,    -1,    -1,    -1,   112,    -1,   148,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,    -1,   241,
     242,   243,    -1,   245,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   253,    -1,   255,   256,   257,   258,   259,   260,   261,
     262,   263,    -1,    -1,    -1,    -1,    -1,   269,    -1,    -1,
     272,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   287,   288,   289,   290,   291,
     292,   293,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   316,   317,   318,   319,   320,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   347,   348,   349,   350,   351,
     352,   353,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   463,   464,   465,   466,   467,   468,   469,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     492,   493,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   510,   511,
     512,   513,    -1,    -1,    -1,    -1,    -1,    -1,   520,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   528,   529,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   571
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    96,   121,   122,   123,   299,   300,    90,   290,     0,
       8,   126,   127,    13,    14,    15,    17,    18,    19,    20,
      23,    24,    25,    26,    28,    29,    30,    31,    32,    34,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    98,
      99,   101,   112,   159,   160,   161,   162,   163,   164,   165,
     167,   168,   170,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   202,   298,   302,   303,   304,   305,   311,   314,    91,
      94,    97,   264,   294,   301,   290,    12,   127,   128,   129,
     290,   290,   290,   290,   290,   290,   290,   290,   290,   290,
      84,   115,   172,   173,   290,   110,   118,   119,   276,   277,
     278,   286,   290,   278,   278,   278,   278,   110,   278,   278,
     278,   278,   278,   278,   278,   278,   278,   110,   290,    43,
     226,   304,   316,   110,   112,   290,     7,   129,   130,   131,
     132,   133,    21,   114,   166,   275,   290,   112,    22,   146,
     275,   275,   146,   166,   112,    88,    89,   169,   169,   172,
     172,    85,    86,    87,    92,    93,   110,   117,   286,   287,
     288,   290,   286,   290,   278,   117,   278,   278,   278,   278,
      13,   200,   201,   278,   278,   278,   278,   278,   278,   278,
     278,   278,     8,    13,    15,    20,    23,    24,    25,    33,
      38,    43,   306,   307,   308,   309,   112,   290,   316,   302,
     290,   124,     8,   134,   135,   133,   278,   275,   112,   112,
     114,   278,   112,   112,   112,   166,   112,   112,   112,   116,
     172,   172,   172,   172,   172,   174,   289,   111,   288,   113,
     279,   113,   113,   113,   290,   113,   273,   274,   290,    90,
     284,   111,   201,   113,   112,   113,   113,   113,   113,   113,
     113,   113,   113,   290,   111,   307,   112,   290,   310,    16,
     111,   110,   103,   104,   105,   106,   136,   137,   138,   139,
     140,   141,   290,   135,   112,   290,   112,    28,    29,    30,
      45,    46,    47,    48,   111,   175,   176,   177,   178,   179,
     180,   181,   305,   290,   278,   290,   278,   278,   278,   112,
     278,   112,   117,   113,   110,   112,   278,   278,   278,   278,
     278,   278,   278,   278,   278,   278,   112,   114,   278,   312,
     285,   290,   278,   278,   278,   278,    33,   142,   143,   144,
     145,   138,   139,   140,   141,    11,   110,   278,   278,   278,
     278,   278,   278,   278,    27,   171,   290,   290,   290,   290,
     273,   274,   275,   200,   278,   278,   278,   278,   278,   290,
     290,   290,   290,   290,    39,   227,    27,   313,   315,   111,
     290,    53,    54,    53,    54,    53,    54,    53,    54,   290,
     100,   112,   157,   158,   159,   160,   170,   297,   311,    34,
     145,   147,   290,   285,   278,   278,   278,   278,   278,   278,
     278,   110,     5,   112,   293,   112,   112,   112,   112,   111,
     112,   112,   112,   112,   112,   110,   265,   266,   270,   276,
     294,   265,   265,   265,   274,   112,   110,   112,   112,   112,
     112,   112,   112,   107,   108,   109,   107,   108,   109,   112,
     146,   290,   158,   225,   226,   110,   290,    38,   148,   149,
     150,   110,   111,   113,   113,   113,   113,   113,   113,   113,
     174,   112,   266,   267,   268,   270,   112,   266,   270,   112,
     112,   112,    40,   302,   112,   112,   112,   112,   112,   112,
     112,   112,     9,    10,   203,   204,   205,   206,   207,   226,
     285,   290,    39,   151,   152,   150,   285,   278,   278,   278,
     278,   278,   278,   278,   111,   111,   268,   117,   273,   111,
     278,   278,   125,   205,   111,   112,   146,   290,    41,    42,
     152,   153,   154,   155,   156,   111,   290,   290,   290,   278,
     278,   278,   278,   269,   278,    13,    53,    54,    55,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    84,   115,   208,   209,    12,   228,   229,   112,   112,
     113,   278,   278,   154,   112,   293,   112,   112,   112,   112,
     112,   112,   270,   208,    35,    36,    37,    92,    93,   223,
     224,    13,    20,    13,    20,   223,   223,   223,   223,   224,
     223,   223,   223,   223,   223,   224,   224,   224,   208,   208,
      85,    86,   112,   290,    56,   229,   238,   239,   240,   275,
     278,   208,   112,   112,   219,   221,   220,   222,    72,   210,
     211,   212,   213,    75,   214,   215,    78,   216,   217,   218,
      81,    82,    83,    83,    81,    83,   116,   208,   208,   271,
     290,   294,    67,    68,    69,   257,   258,   259,   240,   112,
     208,   112,   110,   276,   277,   280,   281,   282,   284,   282,
     282,   282,   282,   282,   282,   282,   282,   282,   282,   282,
     282,   113,   294,    90,   102,   291,   290,   290,    70,   260,
     261,   262,   259,   112,   283,   284,   110,   284,   290,   271,
     271,   271,   271,   291,    57,   241,   242,   243,   244,   262,
     111,   284,   283,   113,   271,   112,   112,   112,     3,     4,
     292,   290,    62,    63,    64,    65,    66,   230,   231,   232,
     233,   234,   235,   236,   237,    58,   251,   252,   253,   244,
     111,   290,   117,   271,   294,   294,    91,   295,   294,   294,
     292,    60,   245,   246,   247,   232,   290,    59,   254,   255,
     256,   253,   113,   272,   117,   290,   117,   271,   271,   117,
     271,   117,   271,   271,   271,    95,   296,    61,   248,   249,
     250,   247,   271,   264,   296,   256,   273,   263,   271,   294,
     295,   294,   294,   290,   250,   271,   264,   296,   271,   271,
     271,   271,   117,   271,   294,   271,   271,   294,   271,   271
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   120,   121,   121,   123,   124,   125,   122,   126,   126,
     127,   128,   128,   129,   130,   131,   131,   132,   132,   133,
     134,   134,   135,   135,   135,   136,   136,   137,   137,   137,
     137,   137,   137,   137,   137,   138,   138,   139,   139,   140,
     140,   141,   141,   141,   141,   141,   141,   142,   142,   143,
     144,   144,   145,   145,   146,   147,   147,   148,   148,   149,
     149,   150,   150,   151,   151,   152,   152,   153,   153,   154,
     154,   155,   156,   157,   157,   158,   158,   158,   158,   158,
     158,   159,   159,   159,   159,   159,   159,   159,   160,   160,
     160,   160,   160,   160,   160,   160,   160,   160,   160,   161,
     162,   162,   163,   164,   165,   166,   166,   167,   168,   169,
     169,   170,   171,   171,   172,   172,   172,   172,   172,   172,
     172,   172,   173,   174,   174,   175,   175,   175,   176,   176,
     176,   176,   177,   177,   177,   177,   178,   179,   180,   181,
     182,   182,   182,   182,   183,   183,   184,   184,   184,   184,
     184,   184,   184,   184,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   198,
     199,   200,   200,   201,   201,   202,   203,   203,   204,   204,
     205,   205,   206,   207,   208,   208,   208,   208,   208,   209,
     209,   209,   210,   209,   211,   209,   212,   209,   213,   209,
     214,   209,   215,   209,   216,   209,   217,   209,   218,   209,
     209,   219,   209,   220,   209,   209,   221,   209,   222,   209,
     209,   209,   209,   209,   209,   209,   223,   223,   224,   224,
     224,   224,   225,   225,   226,   227,   227,   228,   228,   229,
     230,   230,   231,   231,   232,   232,   232,   232,   232,   233,
     234,   234,   235,   235,   236,   237,   238,   238,   239,   239,
     240,   241,   242,   242,   243,   243,   244,   244,   245,   245,
     246,   246,   247,   247,   248,   248,   249,   249,   250,   251,
     251,   252,   252,   253,   254,   254,   255,   255,   256,   256,
     257,   257,   258,   258,   259,   259,   259,   260,   260,   261,
     261,   262,   263,   262,   262,   264,   265,   265,   265,   265,
     266,   267,   267,   269,   268,   268,   268,   270,   271,   272,
     272,   273,   273,   274,   274,   275,   275,   276,   277,   278,
     278,   278,   278,   278,   279,   278,   280,   281,   282,   282,
     282,   282,   282,   283,   283,   284,   285,   285,   286,   287,
     287,   288,   289,   288,   288,   290,   291,   291,   292,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   301,
     301,   302,   303,   303,   304,   304,   304,   304,   304,   304,
     305,   306,   306,   307,   307,   308,   309,   309,   309,   309,
     309,   309,   309,   309,   309,   310,   310,   312,   311,   313,
     313,   314,   315,   316,   316
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     0,     0,     0,    19,     1,     2,
       2,     1,     2,     2,     2,     1,     0,     1,     2,     5,
       1,     2,     5,     4,     7,     1,     0,     1,     1,     1,
       1,     2,     2,     2,     2,     4,     4,     4,     4,     4,
       4,     5,     5,     5,     5,     5,     5,     1,     0,     5,
       1,     2,     4,     3,     2,     2,     4,     1,     0,     1,
       2,     4,     3,     1,     2,     5,     3,     1,     2,     1,
       1,     5,     4,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       5,     4,     4,     4,     4,     2,     0,     4,     4,     1,
       1,     6,     4,     0,     3,     2,     3,     3,     3,     3,
       3,     1,     1,     2,     0,     1,     1,     1,     8,     7,
       7,     7,     1,     1,     1,     1,     7,     7,     7,     7,
       8,     7,     7,     7,     5,     7,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     7,     7,     7,     7,     7,
       8,     8,     8,     8,     3,     5,     4,     4,     5,     7,
       4,     1,     2,     3,     5,     4,     1,     0,     1,     2,
       1,     1,     5,     4,     3,     2,     3,     3,     1,     3,
       3,     3,     0,     4,     0,     4,     0,     4,     0,     4,
       0,     4,     0,     4,     0,     4,     0,     4,     0,     4,
       1,     0,     4,     0,     4,     2,     0,     4,     0,     4,
       3,     3,     3,     3,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     2,     6,     4,     0,     1,     2,     3,
       1,     0,     1,     2,     1,     1,     1,     1,     1,     3,
       3,     5,     3,     5,     3,     3,     1,     0,     1,     2,
       5,     3,     1,     0,     1,     2,     4,     6,     1,     0,
       1,     2,     4,     6,     1,     0,     1,     2,     4,     1,
       0,     1,     2,     4,     1,     0,     1,     2,     4,     4,
       1,     0,     1,     2,     4,     4,     4,     1,     0,     1,
       2,     6,     0,     7,     4,     1,     1,     1,     2,     2,
       3,     1,     2,     0,     4,     1,     1,     1,     6,     2,
       0,     3,     1,     3,     1,     1,     3,     1,     1,     1,
       1,     1,     2,     2,     0,     4,     1,     1,     1,     3,
       1,     2,     4,     1,     2,     1,     1,     2,     3,     1,
       2,     1,     0,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     2,     4,     1,     1,
       1,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       4,     2,     1,     2,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     0,     6,     4,
       0,     1,     1,     2,     0
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:
#line 168 "policy_parse.y" /* yacc.c:1646  */
    { if (define_policy(pass, 0) == -1) return -1; }
#line 2206 "y.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 170 "policy_parse.y" /* yacc.c:1646  */
    { if (pass == 1) { if (policydb_index_classes(policydbp)) return -1; }
                            else if (pass == 2) { if (policydb_index_others(NULL, policydbp, 0)) return -1; }}
#line 2213 "y.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 173 "policy_parse.y" /* yacc.c:1646  */
    { if (pass == 1) { if (policydb_index_bools(policydbp)) return -1;}
			   else if (pass == 2) { if (policydb_index_others(NULL, policydbp, 0)) return -1;}}
#line 2220 "y.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 181 "policy_parse.y" /* yacc.c:1646  */
    {if (define_class()) return -1;}
#line 2226 "y.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 187 "policy_parse.y" /* yacc.c:1646  */
    {if (define_initial_sid()) return -1;}
#line 2232 "y.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 198 "policy_parse.y" /* yacc.c:1646  */
    {if (define_common_perms()) return -1;}
#line 2238 "y.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 204 "policy_parse.y" /* yacc.c:1646  */
    {if (define_av_perms(FALSE)) return -1;}
#line 2244 "y.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 206 "policy_parse.y" /* yacc.c:1646  */
    {if (define_av_perms(TRUE)) return -1;}
#line 2250 "y.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 208 "policy_parse.y" /* yacc.c:1646  */
    {if (define_av_perms(TRUE)) return -1;}
#line 2256 "y.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 223 "policy_parse.y" /* yacc.c:1646  */
    {if (define_default_user(DEFAULT_SOURCE)) return -1; }
#line 2262 "y.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 225 "policy_parse.y" /* yacc.c:1646  */
    {if (define_default_user(DEFAULT_TARGET)) return -1; }
#line 2268 "y.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 228 "policy_parse.y" /* yacc.c:1646  */
    {if (define_default_role(DEFAULT_SOURCE)) return -1; }
#line 2274 "y.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 230 "policy_parse.y" /* yacc.c:1646  */
    {if (define_default_role(DEFAULT_TARGET)) return -1; }
#line 2280 "y.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 233 "policy_parse.y" /* yacc.c:1646  */
    {if (define_default_type(DEFAULT_SOURCE)) return -1; }
#line 2286 "y.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 235 "policy_parse.y" /* yacc.c:1646  */
    {if (define_default_type(DEFAULT_TARGET)) return -1; }
#line 2292 "y.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 238 "policy_parse.y" /* yacc.c:1646  */
    {if (define_default_range(DEFAULT_SOURCE_LOW)) return -1; }
#line 2298 "y.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 240 "policy_parse.y" /* yacc.c:1646  */
    {if (define_default_range(DEFAULT_SOURCE_HIGH)) return -1; }
#line 2304 "y.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 242 "policy_parse.y" /* yacc.c:1646  */
    {if (define_default_range(DEFAULT_SOURCE_LOW_HIGH)) return -1; }
#line 2310 "y.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 244 "policy_parse.y" /* yacc.c:1646  */
    {if (define_default_range(DEFAULT_TARGET_LOW)) return -1; }
#line 2316 "y.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 246 "policy_parse.y" /* yacc.c:1646  */
    {if (define_default_range(DEFAULT_TARGET_HIGH)) return -1; }
#line 2322 "y.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 248 "policy_parse.y" /* yacc.c:1646  */
    {if (define_default_range(DEFAULT_TARGET_LOW_HIGH)) return -1; }
#line 2328 "y.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 259 "policy_parse.y" /* yacc.c:1646  */
    {if (define_sens()) return -1;}
#line 2334 "y.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 261 "policy_parse.y" /* yacc.c:1646  */
    {if (define_sens()) return -1;}
#line 2340 "y.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 266 "policy_parse.y" /* yacc.c:1646  */
    {if (define_dominance()) return -1;}
#line 2346 "y.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 268 "policy_parse.y" /* yacc.c:1646  */
    {if (define_dominance()) return -1;}
#line 2352 "y.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 277 "policy_parse.y" /* yacc.c:1646  */
    {if (define_category()) return -1;}
#line 2358 "y.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 279 "policy_parse.y" /* yacc.c:1646  */
    {if (define_category()) return -1;}
#line 2364 "y.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 285 "policy_parse.y" /* yacc.c:1646  */
    {if (define_level()) return -1;}
#line 2370 "y.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 287 "policy_parse.y" /* yacc.c:1646  */
    {if (define_level()) return -1;}
#line 2376 "y.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 296 "policy_parse.y" /* yacc.c:1646  */
    { if (define_constraint((constraint_expr_t*)(yyvsp[-1].valptr))) return -1; }
#line 2382 "y.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 299 "policy_parse.y" /* yacc.c:1646  */
    { if (define_validatetrans((constraint_expr_t*)(yyvsp[-1].valptr))) return -1; }
#line 2388 "y.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 332 "policy_parse.y" /* yacc.c:1646  */
    { if (define_attrib()) return -1;}
#line 2394 "y.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 335 "policy_parse.y" /* yacc.c:1646  */
    {if (define_type(1)) return -1;}
#line 2400 "y.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 337 "policy_parse.y" /* yacc.c:1646  */
    {if (define_type(0)) return -1;}
#line 2406 "y.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 340 "policy_parse.y" /* yacc.c:1646  */
    {if (define_typealias()) return -1;}
#line 2412 "y.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 343 "policy_parse.y" /* yacc.c:1646  */
    {if (define_typeattribute()) return -1;}
#line 2418 "y.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 346 "policy_parse.y" /* yacc.c:1646  */
    {if (define_typebounds()) return -1;}
#line 2424 "y.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 352 "policy_parse.y" /* yacc.c:1646  */
    { if (define_bool_tunable(0)) return -1; }
#line 2430 "y.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 355 "policy_parse.y" /* yacc.c:1646  */
    { if (define_bool_tunable(1)) return -1; }
#line 2436 "y.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 358 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_id("T",0)) return -1; }
#line 2442 "y.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 360 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_id("F",0)) return -1; }
#line 2448 "y.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 363 "policy_parse.y" /* yacc.c:1646  */
    { if (pass == 2) { if (define_conditional((cond_expr_t*)(yyvsp[-4].ptr), (avrule_t*)(yyvsp[-2].ptr), (avrule_t*)(yyvsp[0].ptr)) < 0) return -1;  }}
#line 2454 "y.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 366 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = (yyvsp[-1].ptr); }
#line 2460 "y.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 368 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = NULL; }
#line 2466 "y.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 371 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = (yyvsp[-1].ptr);}
#line 2472 "y.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 373 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = define_cond_expr(COND_NOT, (yyvsp[0].ptr), 0);
			  if ((yyval.ptr) == 0) return -1; }
#line 2479 "y.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 376 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = define_cond_expr(COND_AND, (yyvsp[-2].ptr), (yyvsp[0].ptr));
			  if ((yyval.ptr) == 0) return  -1; }
#line 2486 "y.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 379 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = define_cond_expr(COND_OR, (yyvsp[-2].ptr), (yyvsp[0].ptr));
			  if ((yyval.ptr) == 0) return   -1; }
#line 2493 "y.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 382 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = define_cond_expr(COND_XOR, (yyvsp[-2].ptr), (yyvsp[0].ptr));
			  if ((yyval.ptr) == 0) return  -1; }
#line 2500 "y.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 385 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = define_cond_expr(COND_EQ, (yyvsp[-2].ptr), (yyvsp[0].ptr));
			  if ((yyval.ptr) == 0) return  -1; }
#line 2507 "y.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 388 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = define_cond_expr(COND_NEQ, (yyvsp[-2].ptr), (yyvsp[0].ptr));
			  if ((yyval.ptr) == 0) return  -1; }
#line 2514 "y.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 391 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = (yyvsp[0].ptr); }
#line 2520 "y.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 394 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = define_cond_expr(COND_BOOL,0, 0);
			  if ((yyval.ptr) == COND_ERR) return   -1; }
#line 2527 "y.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 398 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = define_cond_pol_list((avrule_t *)(yyvsp[-1].ptr), (avrule_t *)(yyvsp[0].ptr)); }
#line 2533 "y.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 400 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = NULL; }
#line 2539 "y.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 403 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = (yyvsp[0].ptr); }
#line 2545 "y.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 405 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = (yyvsp[0].ptr); }
#line 2551 "y.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 407 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = NULL; }
#line 2557 "y.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 410 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = define_cond_filename_trans() ;
                          if ((yyval.ptr) == COND_ERR) return -1;}
#line 2564 "y.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 413 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = define_cond_compute_type(AVRULE_TRANSITION) ;
                          if ((yyval.ptr) == COND_ERR) return -1;}
#line 2571 "y.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 416 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = define_cond_compute_type(AVRULE_MEMBER) ;
                          if ((yyval.ptr) ==  COND_ERR) return -1;}
#line 2578 "y.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 419 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = define_cond_compute_type(AVRULE_CHANGE) ;
                          if ((yyval.ptr) == COND_ERR) return -1;}
#line 2585 "y.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 423 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = (yyvsp[0].ptr); }
#line 2591 "y.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 425 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = (yyvsp[0].ptr); }
#line 2597 "y.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 427 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = (yyvsp[0].ptr); }
#line 2603 "y.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 429 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = (yyvsp[0].ptr); }
#line 2609 "y.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 432 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = define_cond_te_avtab(AVRULE_ALLOWED) ;
                          if ((yyval.ptr) == COND_ERR) return -1; }
#line 2616 "y.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 436 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = define_cond_te_avtab(AVRULE_AUDITALLOW) ;
                          if ((yyval.ptr) == COND_ERR) return -1; }
#line 2623 "y.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 440 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = define_cond_te_avtab(AVRULE_AUDITDENY) ;
                          if ((yyval.ptr) == COND_ERR) return -1; }
#line 2630 "y.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 444 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = define_cond_te_avtab(AVRULE_DONTAUDIT);
                          if ((yyval.ptr) == COND_ERR) return -1; }
#line 2637 "y.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 449 "policy_parse.y" /* yacc.c:1646  */
    {if (define_filename_trans()) return -1; }
#line 2643 "y.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 451 "policy_parse.y" /* yacc.c:1646  */
    {if (define_compute_type(AVRULE_TRANSITION)) return -1;}
#line 2649 "y.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 453 "policy_parse.y" /* yacc.c:1646  */
    {if (define_compute_type(AVRULE_MEMBER)) return -1;}
#line 2655 "y.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 455 "policy_parse.y" /* yacc.c:1646  */
    {if (define_compute_type(AVRULE_CHANGE)) return -1;}
#line 2661 "y.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 458 "policy_parse.y" /* yacc.c:1646  */
    { if (define_range_trans(0)) return -1; }
#line 2667 "y.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 460 "policy_parse.y" /* yacc.c:1646  */
    { if (define_range_trans(1)) return -1; }
#line 2673 "y.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 473 "policy_parse.y" /* yacc.c:1646  */
    {if (define_te_avtab(AVRULE_ALLOWED)) return -1; }
#line 2679 "y.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 476 "policy_parse.y" /* yacc.c:1646  */
    {if (define_te_avtab(AVRULE_AUDITALLOW)) return -1; }
#line 2685 "y.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 479 "policy_parse.y" /* yacc.c:1646  */
    {if (define_te_avtab(AVRULE_AUDITDENY)) return -1; }
#line 2691 "y.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 482 "policy_parse.y" /* yacc.c:1646  */
    {if (define_te_avtab(AVRULE_DONTAUDIT)) return -1; }
#line 2697 "y.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 485 "policy_parse.y" /* yacc.c:1646  */
    {if (define_te_avtab(AVRULE_NEVERALLOW)) return -1; }
#line 2703 "y.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 488 "policy_parse.y" /* yacc.c:1646  */
    {if (define_te_avtab_extended_perms(AVRULE_XPERMS_ALLOWED)) return -1; }
#line 2709 "y.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 491 "policy_parse.y" /* yacc.c:1646  */
    {if (define_te_avtab_extended_perms(AVRULE_XPERMS_AUDITALLOW)) return -1; }
#line 2715 "y.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 494 "policy_parse.y" /* yacc.c:1646  */
    {if (define_te_avtab_extended_perms(AVRULE_XPERMS_DONTAUDIT)) return -1; }
#line 2721 "y.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 497 "policy_parse.y" /* yacc.c:1646  */
    {if (define_te_avtab_extended_perms(AVRULE_XPERMS_NEVERALLOW)) return -1; }
#line 2727 "y.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 500 "policy_parse.y" /* yacc.c:1646  */
    {if (define_attrib_role()) return -1; }
#line 2733 "y.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 503 "policy_parse.y" /* yacc.c:1646  */
    {if (define_role_types()) return -1;}
#line 2739 "y.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 506 "policy_parse.y" /* yacc.c:1646  */
    {if (define_role_attr()) return -1;}
#line 2745 "y.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 511 "policy_parse.y" /* yacc.c:1646  */
    {if (define_role_trans(0)) return -1; }
#line 2751 "y.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 513 "policy_parse.y" /* yacc.c:1646  */
    {if (define_role_trans(1)) return -1;}
#line 2757 "y.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 516 "policy_parse.y" /* yacc.c:1646  */
    {if (define_role_allow()) return -1; }
#line 2763 "y.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 519 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = (yyvsp[0].ptr); }
#line 2769 "y.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 521 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.ptr) = merge_roles_dom((role_datum_t*)(yyvsp[-1].ptr), (role_datum_t*)(yyvsp[0].ptr)); if ((yyval.ptr) == 0) return -1;}
#line 2775 "y.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 524 "policy_parse.y" /* yacc.c:1646  */
    {(yyval.ptr) = define_role_dom(NULL); if ((yyval.ptr) == 0) return -1;}
#line 2781 "y.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 526 "policy_parse.y" /* yacc.c:1646  */
    {(yyval.ptr) = define_role_dom((role_datum_t*)(yyvsp[-1].ptr)); if ((yyval.ptr) == 0) return -1;}
#line 2787 "y.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 529 "policy_parse.y" /* yacc.c:1646  */
    {if (define_roleattribute()) return -1;}
#line 2793 "y.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 541 "policy_parse.y" /* yacc.c:1646  */
    { if (define_constraint((constraint_expr_t*)(yyvsp[-1].valptr))) return -1; }
#line 2799 "y.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 544 "policy_parse.y" /* yacc.c:1646  */
    { if (define_validatetrans((constraint_expr_t*)(yyvsp[-1].valptr))) return -1; }
#line 2805 "y.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 547 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = (yyvsp[-1].valptr); }
#line 2811 "y.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 549 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_NOT, (yyvsp[0].valptr), 0);
			  if ((yyval.valptr) == 0) return -1; }
#line 2818 "y.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 552 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_AND, (yyvsp[-2].valptr), (yyvsp[0].valptr));
			  if ((yyval.valptr) == 0) return -1; }
#line 2825 "y.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 555 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_OR, (yyvsp[-2].valptr), (yyvsp[0].valptr));
			  if ((yyval.valptr) == 0) return -1; }
#line 2832 "y.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 558 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = (yyvsp[0].valptr); }
#line 2838 "y.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 561 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_USER, (yyvsp[-1].valptr));
			  if ((yyval.valptr) == 0) return -1; }
#line 2845 "y.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 564 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_ROLE, (yyvsp[-1].valptr));
			  if ((yyval.valptr) == 0) return -1; }
#line 2852 "y.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 567 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_TYPE, (yyvsp[-1].valptr));
			  if ((yyval.valptr) == 0) return -1; }
#line 2859 "y.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 569 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_separator(1)) return -1; }
#line 2865 "y.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 570 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_USER, (yyvsp[-2].valptr));
			  if ((yyval.valptr) == 0) return -1; }
#line 2872 "y.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 572 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_separator(1)) return -1; }
#line 2878 "y.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 573 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_USER | CEXPR_TARGET), (yyvsp[-2].valptr));
			  if ((yyval.valptr) == 0) return -1; }
#line 2885 "y.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 575 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_separator(1)) return -1; }
#line 2891 "y.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 576 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_USER | CEXPR_XTARGET), (yyvsp[-2].valptr));
			  if ((yyval.valptr) == 0) return -1; }
#line 2898 "y.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 578 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_separator(1)) return -1; }
#line 2904 "y.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 579 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_ROLE, (yyvsp[-2].valptr));
			  if ((yyval.valptr) == 0) return -1; }
#line 2911 "y.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 581 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_separator(1)) return -1; }
#line 2917 "y.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 582 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_TARGET), (yyvsp[-2].valptr));
			  if ((yyval.valptr) == 0) return -1; }
#line 2924 "y.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 584 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_separator(1)) return -1; }
#line 2930 "y.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 585 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_XTARGET), (yyvsp[-2].valptr));
			  if ((yyval.valptr) == 0) return -1; }
#line 2937 "y.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 587 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_separator(1)) return -1; }
#line 2943 "y.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 588 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_TYPE, (yyvsp[-2].valptr));
			  if ((yyval.valptr) == 0) return -1; }
#line 2950 "y.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 590 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_separator(1)) return -1; }
#line 2956 "y.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 591 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_TARGET), (yyvsp[-2].valptr));
			  if ((yyval.valptr) == 0) return -1; }
#line 2963 "y.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 593 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_separator(1)) return -1; }
#line 2969 "y.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 594 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_XTARGET), (yyvsp[-2].valptr));
			  if ((yyval.valptr) == 0) return -1; }
#line 2976 "y.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 597 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_USER, CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
#line 2983 "y.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 599 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_separator(1)) return -1; }
#line 2989 "y.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 600 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_ROLE, CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
#line 2996 "y.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 602 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_separator(1)) return -1; }
#line 3002 "y.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 603 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_TARGET), CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
#line 3009 "y.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 606 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_ROLE, (yyvsp[0].valptr));
			  if ((yyval.valptr) == 0) return -1; }
#line 3016 "y.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 608 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_separator(1)) return -1; }
#line 3022 "y.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 609 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_TYPE, CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
#line 3029 "y.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 611 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_separator(1)) return -1; }
#line 3035 "y.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 612 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_TARGET), CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
#line 3042 "y.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 615 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_L1L2, (yyvsp[-1].valptr));
			  if ((yyval.valptr) == 0) return -1; }
#line 3049 "y.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 618 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_L1H2, (yyvsp[-1].valptr));
			  if ((yyval.valptr) == 0) return -1; }
#line 3056 "y.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 621 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_H1L2, (yyvsp[-1].valptr));
			  if ((yyval.valptr) == 0) return -1; }
#line 3063 "y.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 624 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_H1H2, (yyvsp[-1].valptr));
			  if ((yyval.valptr) == 0) return -1; }
#line 3070 "y.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 627 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_L1H1, (yyvsp[-1].valptr));
			  if ((yyval.valptr) == 0) return -1; }
#line 3077 "y.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 630 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_L2H2, (yyvsp[-1].valptr));
			  if ((yyval.valptr) == 0) return -1; }
#line 3084 "y.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 634 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = CEXPR_EQ; }
#line 3090 "y.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 636 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = CEXPR_NEQ; }
#line 3096 "y.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 639 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = (yyvsp[0].valptr); }
#line 3102 "y.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 641 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = CEXPR_DOM; }
#line 3108 "y.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 643 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = CEXPR_DOMBY; }
#line 3114 "y.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 645 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.valptr) = CEXPR_INCOMP; }
#line 3120 "y.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 651 "policy_parse.y" /* yacc.c:1646  */
    {if (define_user()) return -1;}
#line 3126 "y.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 660 "policy_parse.y" /* yacc.c:1646  */
    {if (define_initial_sid_context()) return -1;}
#line 3132 "y.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 674 "policy_parse.y" /* yacc.c:1646  */
    {if (define_pirq_context((yyvsp[-1].val))) return -1;}
#line 3138 "y.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 677 "policy_parse.y" /* yacc.c:1646  */
    {if (define_iomem_context((yyvsp[-1].val64),(yyvsp[-1].val64))) return -1;}
#line 3144 "y.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 679 "policy_parse.y" /* yacc.c:1646  */
    {if (define_iomem_context((yyvsp[-3].val64),(yyvsp[-1].val64))) return -1;}
#line 3150 "y.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 682 "policy_parse.y" /* yacc.c:1646  */
    {if (define_ioport_context((yyvsp[-1].val),(yyvsp[-1].val))) return -1;}
#line 3156 "y.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 684 "policy_parse.y" /* yacc.c:1646  */
    {if (define_ioport_context((yyvsp[-3].val),(yyvsp[-1].val))) return -1;}
#line 3162 "y.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 687 "policy_parse.y" /* yacc.c:1646  */
    {if (define_pcidevice_context((yyvsp[-1].val))) return -1;}
#line 3168 "y.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 690 "policy_parse.y" /* yacc.c:1646  */
    {if (define_devicetree_context()) return -1;}
#line 3174 "y.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 699 "policy_parse.y" /* yacc.c:1646  */
    {if (define_fs_context((yyvsp[-3].val),(yyvsp[-2].val))) return -1;}
#line 3180 "y.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 710 "policy_parse.y" /* yacc.c:1646  */
    {if (define_port_context((yyvsp[-1].val),(yyvsp[-1].val))) return -1;}
#line 3186 "y.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 712 "policy_parse.y" /* yacc.c:1646  */
    {if (define_port_context((yyvsp[-3].val),(yyvsp[-1].val))) return -1;}
#line 3192 "y.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 721 "policy_parse.y" /* yacc.c:1646  */
    {if (define_ibpkey_context((yyvsp[-1].val),(yyvsp[-1].val))) return -1;}
#line 3198 "y.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 723 "policy_parse.y" /* yacc.c:1646  */
    {if (define_ibpkey_context((yyvsp[-3].val),(yyvsp[-1].val))) return -1;}
#line 3204 "y.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 732 "policy_parse.y" /* yacc.c:1646  */
    {if (define_ibendport_context((yyvsp[-1].val))) return -1;}
#line 3210 "y.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 741 "policy_parse.y" /* yacc.c:1646  */
    {if (define_netif_context()) return -1;}
#line 3216 "y.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 750 "policy_parse.y" /* yacc.c:1646  */
    {if (define_ipv4_node_context()) return -1;}
#line 3222 "y.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 752 "policy_parse.y" /* yacc.c:1646  */
    {if (define_ipv6_node_context()) return -1;}
#line 3228 "y.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 761 "policy_parse.y" /* yacc.c:1646  */
    {if (define_fs_use(SECURITY_FS_USE_XATTR)) return -1;}
#line 3234 "y.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 763 "policy_parse.y" /* yacc.c:1646  */
    {if (define_fs_use(SECURITY_FS_USE_TASK)) return -1;}
#line 3240 "y.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 765 "policy_parse.y" /* yacc.c:1646  */
    {if (define_fs_use(SECURITY_FS_USE_TRANS)) return -1;}
#line 3246 "y.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 774 "policy_parse.y" /* yacc.c:1646  */
    {if (define_genfs_context(1)) return -1;}
#line 3252 "y.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 775 "policy_parse.y" /* yacc.c:1646  */
    {insert_id("-", 0);}
#line 3258 "y.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 776 "policy_parse.y" /* yacc.c:1646  */
    {if (define_genfs_context(1)) return -1;}
#line 3264 "y.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 778 "policy_parse.y" /* yacc.c:1646  */
    {if (define_genfs_context(0)) return -1;}
#line 3270 "y.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 781 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_id(yytext,0)) return -1; }
#line 3276 "y.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 784 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_separator(0)) return -1; }
#line 3282 "y.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 786 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_separator(0)) return -1; }
#line 3288 "y.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 788 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_id("~", 0)) return -1; }
#line 3294 "y.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 790 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_id("~", 0)) return -1;
			  if (insert_separator(0)) return -1; }
#line 3301 "y.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 798 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_id("-", 0)) return -1; }
#line 3307 "y.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 803 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_id(yytext,0)) return -1; }
#line 3313 "y.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 811 "policy_parse.y" /* yacc.c:1646  */
    {if (insert_separator(0)) return -1;}
#line 3319 "y.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 813 "policy_parse.y" /* yacc.c:1646  */
    {if (insert_separator(0)) return -1;}
#line 3325 "y.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 816 "policy_parse.y" /* yacc.c:1646  */
    {if (insert_separator(0)) return -1;}
#line 3331 "y.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 818 "policy_parse.y" /* yacc.c:1646  */
    {if (insert_separator(0)) return -1;}
#line 3337 "y.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 828 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_separator(0)) return -1; }
#line 3343 "y.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 830 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_separator(0)) return -1; }
#line 3349 "y.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 832 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_id("*", 0)) return -1; 
			  if (insert_separator(0)) return -1; }
#line 3356 "y.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 835 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_id("~", 0)) return -1;
			  if (insert_separator(0)) return -1; }
#line 3363 "y.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 838 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_id("~", 0)) return -1; 
			  if (insert_separator(0)) return -1; }
#line 3370 "y.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 840 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_id("-", 0)) return -1; }
#line 3376 "y.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 841 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_separator(0)) return -1; }
#line 3382 "y.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 844 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_id("~", 1)) return -1; }
#line 3388 "y.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 847 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_id("*", 1)) return -1; }
#line 3394 "y.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 859 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_id(yytext, 1)) return -1; }
#line 3400 "y.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 868 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_id("-", 0)) return -1; }
#line 3406 "y.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 871 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_id(yytext,0)) return -1; }
#line 3412 "y.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 874 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_id(yytext,0)) return -1; }
#line 3418 "y.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 876 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_id(yytext,0)) return -1; }
#line 3424 "y.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 879 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_id(yytext,0)) return -1; }
#line 3430 "y.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 881 "policy_parse.y" /* yacc.c:1646  */
    { yytext[strlen(yytext) - 1] = '\0'; if (insert_id(yytext + 1,0)) return -1; }
#line 3436 "y.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 884 "policy_parse.y" /* yacc.c:1646  */
    { yytext[strlen(yytext) - 1] = '\0'; if (insert_id(yytext + 1,0)) return -1; }
#line 3442 "y.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 887 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.val) = strtoul(yytext,NULL,0); }
#line 3448 "y.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 890 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.val64) = strtoull(yytext,NULL,0); }
#line 3454 "y.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 893 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_id(yytext,0)) return -1; }
#line 3460 "y.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 896 "policy_parse.y" /* yacc.c:1646  */
    {if (define_polcap()) return -1;}
#line 3466 "y.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 899 "policy_parse.y" /* yacc.c:1646  */
    {if (define_permissive()) return -1;}
#line 3472 "y.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 904 "policy_parse.y" /* yacc.c:1646  */
    { if (end_avrule_block(pass) == -1) return -1;
                          if (policydb_index_others(NULL, policydbp, 0)) return -1;
                        }
#line 3480 "y.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 909 "policy_parse.y" /* yacc.c:1646  */
    { if (define_policy(pass, 1) == -1) return -1; }
#line 3486 "y.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 912 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_id(yytext,0)) return -1; }
#line 3492 "y.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 914 "policy_parse.y" /* yacc.c:1646  */
    { if (insert_id(yytext,0)) return -1; }
#line 3498 "y.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 938 "policy_parse.y" /* yacc.c:1646  */
    { if (require_class(pass)) return -1; }
#line 3504 "y.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 940 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.require_func) = require_role; }
#line 3510 "y.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 941 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.require_func) = require_type; }
#line 3516 "y.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 942 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.require_func) = require_attribute; }
#line 3522 "y.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 943 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.require_func) = require_attribute_role; }
#line 3528 "y.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 944 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.require_func) = require_user; }
#line 3534 "y.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 945 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.require_func) = require_bool; }
#line 3540 "y.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 946 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.require_func) = require_tunable; }
#line 3546 "y.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 947 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.require_func) = require_sens; }
#line 3552 "y.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 948 "policy_parse.y" /* yacc.c:1646  */
    { (yyval.require_func) = require_cat; }
#line 3558 "y.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 951 "policy_parse.y" /* yacc.c:1646  */
    { if ((yyvsp[-1].require_func) (pass)) return -1; }
#line 3564 "y.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 953 "policy_parse.y" /* yacc.c:1646  */
    { if ((yyvsp[-3].require_func) (pass)) return -1; }
#line 3570 "y.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 956 "policy_parse.y" /* yacc.c:1646  */
    { if (end_avrule_block(pass) == -1) return -1; }
#line 3576 "y.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 958 "policy_parse.y" /* yacc.c:1646  */
    { if (end_optional(pass) == -1) return -1; }
#line 3582 "y.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 961 "policy_parse.y" /* yacc.c:1646  */
    { if (end_avrule_block(pass) == -1) return -1; }
#line 3588 "y.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 965 "policy_parse.y" /* yacc.c:1646  */
    { if (begin_optional(pass) == -1) return -1; }
#line 3594 "y.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 968 "policy_parse.y" /* yacc.c:1646  */
    { if (begin_optional_else(pass) == -1) return -1; }
#line 3600 "y.tab.c" /* yacc.c:1646  */
    break;


#line 3604 "y.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
